#ifndef _DRV_IF_H_
#define _DRV_IF_H_

#include <stdint.h>
#include "board_key.h"
#include "board.h"
#include "drv_spi.h"
#include "drv_uart.h"
#include "drv_spi.h"

extern PIN_Handle m_ledPinHandle;

extern PIN_Handle m_cs1PinHandle;

extern PIN_Handle m_cs2PinHandle;
extern PIN_Handle m_rstPinHandle;

#define LED_RUN_ON                  PIN_setOutputValue(m_ledPinHandle, LED_RUN, 1)
#define LED_RUN_OFF                 PIN_setOutputValue(m_ledPinHandle, LED_RUN, 0)

#define MCP_CS_EN                   PIN_setOutputValue(m_cs1PinHandle, MCP_SPI0_CS, 0)      
#define MCP_CS_DIS                  PIN_setOutputValue(m_cs1PinHandle, MCP_SPI0_CS, 1)  


#define MCP_RST_HIGH                PIN_setOutputValue(m_rstPinHandle, MCP_SPI0_RST, 1)      
#define MCP_RST_LOW                 PIN_setOutputValue(m_rstPinHandle, MCP_SPI0_RST, 0)  



#define IF_TRUE		1
#define IF_FALSE	0



void Init_HardWareIO();

void led_Turn(void);

void switchMux(unsigned char code);


#endif