#ifndef __DRV_MCP3914_H__
#define __DRV_MCP3914_H__



#ifndef MCP_TRUE 
#define MCP_TRUE		1
#endif

#ifndef MCP_FALSE 
#define MCP_FALSE		0
#endif // !MCP_FALSE 


#ifndef  MCP_NULL
#define  MCP_NULL		0
#endif // ! MCP_NULL





//ͨĴ 24λ
#define MCP_DATA_CH0	0X00
#define MCP_DATA_CH1	0X01
#define MCP_DATA_CH2	0X02
#define MCP_DATA_CH3	0X03
#define MCP_DATA_CH4	0X04
#define MCP_DATA_CH5	0X05
#define MCP_DATA_CH6	0X06
#define MCP_DATA_CH7	0X07

//Ĵ  32λ
#define MCP_MODE		0X08

//λüĴ024λ,Ӧͨ6/7λʱ 4/5λʱ 
#define MCP_PHASE0		0X09
//λüĴ124λ,Ӧͨ2/3λʱ 0/1λʱ 
#define MCP_PHASE1		0X0A

//Ĵ24λ8飬ÿλӦһͨ gain = 2Nη
#define MCP_GAIN		0X0B

//״̬ͨżĴǳҪ
#define MCP_STCOM		0X0C

//üĴ0 У׼Ƶ
#define MCP_CONFIG0		0X0D

//üĴ1 λػʱѡ
#define MCP_CONFIG1		0X0E

#define MCP_OFSL_CH0	0X0F
#define MCP_GAIN_CH0	0X10
#define MCP_OFSL_CH1	0X11
#define MCP_GAIN_CH1	0X12
#define MCP_OFSL_CH2	0X13
#define MCP_GAIN_CH2	0X14
#define MCP_OFSL_CH3	0X15
#define MCP_GAIN_CH3	0X16
#define MCP_OFSL_CH4	0X17
#define MCP_GAIN_CH4	0X18
#define MCP_OFSL_CH5	0X19
#define MCP_GAIN_CH5	0X1A
#define MCP_OFSL_CH6	0X1B
#define MCP_GAIN_CH6	0X1C
#define MCP_OFSL_CH7	0X1D
#define MCP_GAIN_CH7	0X1E
#define MCP_LOCK_CRC	0X1F

//üĴ0
typedef union  
{
	struct 
	{
		unsigned int VREFCAL	: 8;//ڲѹ¶ϵ

		unsigned int rsv		: 5;//
		unsigned int OSR		: 3;//ADת

		unsigned int PRE		: 2;//ԤƵֵ
		unsigned int BOOST		: 2;//ƫõѡ
		unsigned int DITHER		: 2;//
		unsigned int EN_GAINCAL : 1;//λǰķʽŲ
		unsigned int EN_OFFCAL	: 1;//ʧУ׼
	}BITS;

	unsigned int BYTES;
}dsRegMcpConfig0;


#define EN_OFFCAL_YES					1
#define EN_OFFCAL_NO_DEFAULT			0

#define EN_GAINCAL_YES					1
#define EN_GAINCAL_NO_DEFAULT			0

#define DITHER_MAX_DEFAULT				3
#define DITHER_MID						2
#define DITHER_MIN						1
#define DITHER_OFF						0


#define BOOST_MULTI_2					3
#define BOOST_MULTI_1_DEFAULT			2
#define BOOST_MULTI_0_P66				1
#define BOOST_MULTI_0_P5				0

#define PRE_DIV_8						3
#define PRE_DIV_4						2
#define PRE_DIV_2						1
#define PRE_DIV_1_DEFAULT				0

#define OSR_4096						7
#define OSR_2048						6
#define OSR_1024						5
#define OSR_512							4
#define OSR_256_DEFAULT					3
#define OSR_128							2
#define OSR_64							1
#define OSR_32							0


#define VREFCAL_DEFAULT					0X50

typedef union 
{
	struct 
	{
		//λǰλںСģʽ
		unsigned int RSV		: 6;//
		unsigned int CLKEXT		: 1;//ڲʱѡλ
		unsigned int VREFEXT	: 1;//ڲοѹѡλ

		unsigned int SHUTDOWN	: 8;//ADCضģʽ, 1ض, 0 ض

		unsigned int RESET : 8;//λģʽ, 1 λ, 0 
	}BITS;

	unsigned int BYTES;
}dsRegMcpConfig1;


#define VREFEXT_YES			1
#define VREFEXT_NO			0

#define CLKEXT_YES			1
#define CLKEXT_NO			0






#define ADC_ROWS		24
#define ADC_COLUMNS		8

typedef struct
{

	//float mapValue[ADC_ROWS][ADC_COLUMNS];

	void(*Init)();

	void(*ResetMCP3914)();

	void(*SwitchChannel)(unsigned char ch);

	unsigned int(*ReadReg)(unsigned char addr);

	void(*WriteReg)(unsigned char adddr, unsigned int data);

	void(*Read_Internal_Registers)(void *args);

	void(*InitSPI)();

	unsigned int(*Read_MCP3914_ADC)(void * args);

	int(*send_If)(void *buffer, unsigned char size);

	unsigned int(*SendAdcValue)();
        
        unsigned int interRegs[24];

	unsigned int adcValue[16];

	unsigned char rowPtr;

	float volBat;

}dsMCPControl;



//ȡ8adcͨԭʼֵ
unsigned int ReadMCP3914_Ave(void* args, unsigned char ch, unsigned char cnt);

unsigned int Read_MCP3914_ADC(void *args);

//mcp ȫֳʼ
void  Init_MCP3914(void *args);


extern dsMCPControl m_mcpHandle;

#endif